Abstract Class: CRUDRoute<T>
Defined in: service-core/src/routes/CRUDRoute.ts:51
The CRUDRoute provides a base implementation of all CRUD endpoint behaviors that ModelRoute offers for a given
data model class. This class provides the most common default settings for each route handler. If you desire additional
functionality you may override the handler function and add desired functionality via additional decorators or override
existing decorator behavior.
The route endpoints provided by this class do not explicitly require authentication. However, if the RBAC system is enabled these handlers will still validate permissions appropriately.
Included Endpoints:
| Name | HTTP Method | What it does |
|---|---|---|
count | HEAD / | Counts the number of objects matching the provided set of criteria in the request's query parameters. Returns the count as the value of the Content-Length header. |
create | POST / | Adds one or more new objects to the datastore. |
delete | DELETE /:id | Removes an existing object from the datastore. |
exists | HEAD /:id | Checks if the object with the given ID exists in the datastore. Sets Content-Length header to 1 if the object exists, otherwise 0. |
find | GET / | Returns all objects matching the provided set of criteria in the request's query parameters. |
findById | GET /:id | Returns a single object with a specified unique identifier. |
truncate | DELETE / | Removes all objects from the datastore. |
update | PUT /:id | Modifies an existing object in the datastore. |
updateBulk | PUT / | Modifies multiple existing objects in the datastore. |
updateProperty | PUT /:id/:property | Modifies an single property of the given name of an existing object in the datastore. |
Extends
ModelRoute<T>
Extended by
Type Parameters
T
T extends BaseEntity | SimpleEntity
Constructors
Constructor
new CRUDRoute<
T>():CRUDRoute<T>
Returns
CRUDRoute<T>
Inherited from
Properties
aclUtils?
protectedoptionalaclUtils?:ACLUtils
Defined in: service-core/src/routes/ModelRoute.ts:121
Inherited from
cacheClient?
protectedoptionalcacheClient?:Redis
Defined in: service-core/src/routes/ModelRoute.ts:125
The redis client that will be used as a 2nd level cache for all cacheable models.
Inherited from
config?
protectedoptionalconfig?:any
Defined in: service-core/src/routes/ModelRoute.ts:129
The global application configuration.
Inherited from
defaultACLUid
protecteddefaultACLUid:string=""
Defined in: service-core/src/routes/ModelRoute.ts:132
The unique identifier of the default ACL for the model type.
Inherited from
logger
protectedlogger:any
Defined in: service-core/src/routes/ModelRoute.ts:135
Inherited from
notificationUtils?
protectedoptionalnotificationUtils?:NotificationUtils
Defined in: service-core/src/routes/ModelRoute.ts:138
Inherited from
objectFactory?
protectedoptionalobjectFactory?:ObjectFactory
Defined in: service-core/src/routes/ModelRoute.ts:141
Inherited from
repoUtils?
protectedoptionalrepoUtils?:RepoUtils<T>
Defined in: service-core/src/routes/ModelRoute.ts:147
The repository utility class to use for common operations.
Inherited from
repoUtilsClass
protectedreadonlyrepoUtilsClass:any=RepoUtils
Defined in: service-core/src/routes/CRUDRoute.ts:52
The class of the RepoUtils to use when instantiating the utility.
Overrides
trackChanges
protectedtrackChanges:number=0
Defined in: service-core/src/routes/ModelRoute.ts:153
The number of previous document versions to store in the database. A negative value indicates storing all
versions, a value of 0 stores no versions.
Inherited from
trustedRoles
protectedtrustedRoles:string[]
Defined in: service-core/src/routes/ModelRoute.ts:156
Inherited from
Accessors
modelClass
Get Signature
get modelClass():
any
Defined in: service-core/src/routes/ModelRoute.ts:161
The class type of the model this route is associated with.
Returns
any
Inherited from
Methods
count()
count(
params,query,res,user?):Promise<any>
Defined in: service-core/src/routes/CRUDRoute.ts:61
Parameters
params
any
query
any
res
user?
JWTUser
Returns
Promise<any>
create()
create(
obj,req,user?):Promise<T|T[]>
Defined in: service-core/src/routes/CRUDRoute.ts:79
Parameters
obj
T | T[]
req
user?
JWTUser
Returns
Promise<T | T[]>
delete()
delete(
id,version,purge,req,user?):Promise<void>
Defined in: service-core/src/routes/CRUDRoute.ts:87
Parameters
id
string
version
string | undefined
purge
string | undefined
req
user?
JWTUser
Returns
Promise<void>
doBulkCreate()
protecteddoBulkCreate(objs,options):Promise<T[]>
Defined in: service-core/src/routes/ModelRoute.ts:259
Attempts to store a collection of objects provided in options.req.body into the datastore. Upon success, sets the newly persisted
object(s) to the result property of the options.res argument, otherwise sends a 400 BAD REQUEST response to the
client.
Parameters
objs
Partial<T>[]
The object(s) to store in the database.
options
The options to process the request using.
Returns
Promise<T[]>
Inherited from
doBulkUpdate()
protecteddoBulkUpdate(objs,options):Promise<T[]>
Defined in: service-core/src/routes/ModelRoute.ts:498
Attempts to modify a collection of existing data model objects.
Parameters
objs
UpdateObject<T>[]
The object(s) to bulk update in the database.
options
The options to process the request using.
Returns
Promise<T[]>
Inherited from
doCount()
protecteddoCount(options):Promise<HttpResponse>
Defined in: service-core/src/routes/ModelRoute.ts:193
Attempts to retrieve the number of data model objects matching the given set of criteria as specified in the
request query. Any results that have been found are set to the content-length header of the res argument.
Parameters
options
The options to process the request using.
Returns
Promise<HttpResponse>
Inherited from
doCreate()
protecteddoCreate(obj,options):Promise<T|T[]>
Defined in: service-core/src/routes/ModelRoute.ts:289
Attempts to store one or more objects provided in options.req.body into the datastore. Upon success, sets the newly persisted
object(s) to the result property of the options.res argument, otherwise sends a 400 BAD REQUEST response to the
client.
Parameters
obj
Partial<T> | Partial<T>[]
The object(s) to store in the database.
options
The options to process the request using.
Returns
Promise<T | T[]>
Inherited from
doCreateObject()
protecteddoCreateObject(obj,options):Promise<T>
Defined in: service-core/src/routes/ModelRoute.ts:229
Attempts to store an object provided in options.req.body into the datastore. Upon success, sets the newly persisted
object(s) to the result property of the options.res argument, otherwise sends a 400 BAD REQUEST response to the
client.
Parameters
obj
Partial<T>
The object to store in the database.
options
The options to process the request using.
Returns
Promise<T>
Inherited from
doDelete()
protecteddoDelete(id,options):Promise<void>
Defined in: service-core/src/routes/ModelRoute.ts:317
Attempts to delete an existing data model object with a given unique identifier encoded by the URI parameter
id.
Parameters
id
string
The unique identifier of the object to delete.
options
The options to process the request using.
Returns
Promise<void>
Inherited from
doExists()
protecteddoExists(id,options):Promise<any>
Defined in: service-core/src/routes/ModelRoute.ts:363
Attempts to determine if an existing object with the given unique identifier exists.
Parameters
id
string
The unique identifier of the object to verify exists.
options
The options to process the request using.
Returns
Promise<any>
Inherited from
doFind()
protecteddoFind(options):Promise<T[]>
Defined in: service-core/src/routes/ModelRoute.ts:397
Attempts to retrieve all data model objects matching the given set of criteria as specified in the request
query. Any results that have been found are set to the result property of the res argument. result is
never null.
Parameters
options
The options to process the request using.
Returns
Promise<T[]>
Inherited from
doFindById()
protecteddoFindById(id,options):Promise<T|null>
Defined in: service-core/src/routes/ModelRoute.ts:424
Attempts to retrieve a single data model object as identified by the id parameter in the URI.
Parameters
id
string
options
The options to process the request using.
Returns
Promise<T | null>
Inherited from
doTruncate()
protecteddoTruncate(options):Promise<void>
Defined in: service-core/src/routes/ModelRoute.ts:459
Attempts to remove all entries of the data model type from the datastore matching the given parameters and query.
Parameters
options
The options to process the request using.
Returns
Promise<void>
Inherited from
doUpdate()
protecteddoUpdate(id,obj,options):Promise<T>
Defined in: service-core/src/routes/ModelRoute.ts:526
Attempts to modify an existing data model object as identified by the id parameter in the URI.
Parameters
id
string
obj
UpdateObject<T>
The object to update in the database
options
The options to process the request using.
Returns
Promise<T>
Inherited from
doUpdateProperty()
protecteddoUpdateProperty(id,propertyName,value,options):Promise<T>
Defined in: service-core/src/routes/ModelRoute.ts:577
Attempts to modify a single property of an existing data model object as identified by the id parameter in the URI.
Note that this effectively bypasses optimistic locking and can cause unexpected data overwrites. Use with care.
Parameters
id
string
The unique identifier of the object to update.
propertyName
string
The name of the property to update.
value
any
The value of the property to set.
options
The options to process the request using.
Returns
Promise<T>
Inherited from
exists()
exists(
id,query,res,user?):Promise<any>
Defined in: service-core/src/routes/CRUDRoute.ts:104
Parameters
id
string
query
any
res
user?
JWTUser
Returns
Promise<any>
find()
find(
params,query,user?):Promise<T[]>
Defined in: service-core/src/routes/CRUDRoute.ts:117
Parameters
params
any
query
any
user?
JWTUser
Returns
Promise<T[]>
findById()
findById(
id,query,user?):Promise<T|null>
Defined in: service-core/src/routes/CRUDRoute.ts:125
Parameters
id
string
query
any
user?
JWTUser
Returns
Promise<T | null>
truncate()
truncate(
params,query,user?):Promise<void>
Defined in: service-core/src/routes/CRUDRoute.ts:133
Parameters
params
any
query
any
user?
JWTUser
Returns
Promise<void>
update()
update(
id,obj,req,user?):Promise<T>
Defined in: service-core/src/routes/CRUDRoute.ts:146
Parameters
id
string
obj
UpdateObject<T>
req
user?
JWTUser
Returns
Promise<T>
updateBulk()
updateBulk(
obj,req,user?):Promise<T[]>
Defined in: service-core/src/routes/CRUDRoute.ts:164
Parameters
obj
UpdateObject<T>[]
req
user?
JWTUser
Returns
Promise<T[]>
updateProperty()
updateProperty(
id,propertyName,obj,user?):Promise<T>
Defined in: service-core/src/routes/CRUDRoute.ts:173
Parameters
id
string
propertyName
string
obj
any
user?
JWTUser
Returns
Promise<T>
validate()
validate(
objs,options?):Promise<void>
Defined in: service-core/src/routes/ModelRoute.ts:619
Calls repoUtils.validate() to validate the object(s) provided.
Parameters
objs
Partial<T> | Partial<T>[]
options?
CreateRequestOptions | UpdateRequestOptions<T>
Returns
Promise<void>
Inherited from
validateCreate()
protectedvalidateCreate(obj,user?):Promise<void>
Defined in: service-core/src/routes/CRUDRoute.ts:70
Parameters
obj
Partial<T> | Partial<T>[]
user?
JWTUser
Returns
Promise<void>
validateUpdate()
protectedvalidateUpdate(id,obj,user?):Promise<void>
Defined in: service-core/src/routes/CRUDRoute.ts:137
Parameters
id
string
obj
UpdateObject<T>
user?
JWTUser
Returns
Promise<void>
validateUpdateBulk()
protectedvalidateUpdateBulk(objs,user?):Promise<void>
Defined in: service-core/src/routes/CRUDRoute.ts:155
Parameters
objs
UpdateObject<T>[]
user?
JWTUser
Returns
Promise<void>